"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _MultiSelectAll = _interopRequireDefault(require("./MultiSelectAll"));
var _animated = _interopRequireDefault(require("react-select/animated"));
var _MySelect = _interopRequireDefault(require("./MySelect"));
var _reactSelect = require("react-select");
var _DefaultDraftBlockRenderMap = require("draft-js/lib/DefaultDraftBlockRenderMap");
var _locale = require("date-fns/locale");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var colourOptions = [{
  value: "ocean",
  label: "Ocean",
  color: "#00B8D9"
}, {
  value: "blue",
  label: "Blue",
  color: "#0052CC"
}, {
  value: "purple",
  label: "Purple",
  color: "#5243AA"
}, {
  value: "red",
  label: "Red",
  color: "#FF5630"
}, {
  value: "orange",
  label: "Orange",
  color: "#FF8B00"
}, {
  value: "yellow",
  label: "Yellow",
  color: "#FFC400"
}, {
  value: "green",
  label: "Green",
  color: "#36B37E"
}, {
  value: "forest",
  label: "Forest",
  color: "#00875A"
}, {
  value: "slate",
  label: "Slate",
  color: "#253858"
}, {
  value: "silver",
  label: "Silver",
  color: "#666666"
}];
var Option = function Option(props) {
  return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_reactSelect.components.Option, props, /*#__PURE__*/_react["default"].createElement("input", {
    type: "checkbox",
    checked: props.isSelected,
    onChange: function onChange() {
      return null;
    }
  }), " ", /*#__PURE__*/_react["default"].createElement("label", null, props.label)));
};
var MultiValue = function MultiValue(props) {
  return /*#__PURE__*/_react["default"].createElement(_reactSelect.components.MultiValue, props, /*#__PURE__*/_react["default"].createElement("span", null, props.data.label));
};
var animatedComponents = (0, _animated["default"])();
var Autocomplete = /*#__PURE__*/function (_Component) {
  _inherits(Autocomplete, _Component);
  var _super = _createSuper(Autocomplete);
  function Autocomplete(props) {
    var _this;
    _classCallCheck(this, Autocomplete);
    _this = _super.call(this, props);
    _defineProperty(_assertThisInitialized(_this), "onChange", function (e) {
      var suggestions = _this.props.suggestions;
      var userInput = e.currentTarget.value;

      // Filter our suggestions that don't contain the user's input
      var filteredSuggestions = suggestions.filter(function (suggestion) {
        return suggestion.title.toLowerCase().indexOf(userInput.toLowerCase()) > -1;
      });
      _this.setState({
        activeSuggestion: 0,
        filteredSuggestions: filteredSuggestions,
        showSuggestions: true,
        userInput: e.currentTarget.value
      });
    });
    _defineProperty(_assertThisInitialized(_this), "onClick", function (params) {
      console.log(_this.state.utilities);
      _this.setState({
        activeSuggestion: 0,
        filteredSuggestions: [],
        showSuggestions: false,
        userInput: params.title,
        properties: params.key,
        addProperties: false
      });
      _this.setState({
        utilities: [].concat(_toConsumableArray(_this.state.utilities), [{
          name: params.title
        }])
      });
    });
    _defineProperty(_assertThisInitialized(_this), "onKeyDown", function (e) {
      var _this$state = _this.state,
        activeSuggestion = _this$state.activeSuggestion,
        filteredSuggestions = _this$state.filteredSuggestions;

      // User pressed the enter key
      if (e.keyCode === 13) {
        _this.setState({
          activeSuggestion: 0,
          showSuggestions: false,
          userInput: filteredSuggestions[activeSuggestion]
        });
      }
      // User pressed the up arrow
      else if (e.keyCode === 38) {
        if (activeSuggestion === 0) {
          return;
        }
        _this.setState({
          activeSuggestion: activeSuggestion - 1
        });
      }
      // User pressed the down arrow
      else if (e.keyCode === 40) {
        if (activeSuggestion - 1 === filteredSuggestions.length) {
          return;
        }
        _this.setState({
          activeSuggestion: activeSuggestion + 1
        });
      }
    });
    _defineProperty(_assertThisInitialized(_this), "handleChange", function (selected) {
      _this.setState({
        optionSelected: selected,
        addProperties: false
      });

      // const result =this.state.utilities.map((value,index)=>  console.log(value))
    });
    _defineProperty(_assertThisInitialized(_this), "deleteUtilities", function (name, indexvalue) {
      var result;
      var result2;
      var delRes;
      _this.state.utilities.map(function (value) {
        var _value$properties;
        result = value === null || value === void 0 ? void 0 : (_value$properties = value.properties) === null || _value$properties === void 0 ? void 0 : _value$properties.filter(function (row, index) {
          return index != indexvalue;
        });
      });
      result2 = _this.state.utilities.filter(function (data, index) {
        return data.name === name;
      });
      result2[0].properties = result;
      // this.setState({utilities: ...this.state.utilities, ...result2});

      // this.setState({ optionSelected: result });
      // console.log(this.state.optionSelected);
    });
    _defineProperty(_assertThisInitialized(_this), "finalSelectedData", function (params) {
      var _this$state$utilities;
      console.log(params);
      console.log(_this.state.utilities);
      (_this$state$utilities = _this.state.utilities) === null || _this$state$utilities === void 0 ? void 0 : _this$state$utilities.map(function (row, index) {
        _this.state.utilities[params].properties = _this.state.optionSelected;
      });
      params++;
      _this.setState({
        number: params
      });
    });
    _this.state = {
      // The active selection's index
      activeSuggestion: 0,
      // The suggestions that match the user's input
      filteredSuggestions: [],
      // Whether or not the suggestion list is shown
      showSuggestions: false,
      // What the user has entered
      userInput: "",
      utilities: [],
      optionSelected: "",
      number: 0
    };
    return _this;
  }
  _createClass(Autocomplete, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var onChange = this.onChange,
        _onClick = this.onClick,
        onKeyDown = this.onKeyDown,
        deleteUtilities = this.deleteUtilities,
        finalSelectedData = this.finalSelectedData,
        _this$state2 = this.state,
        activeSuggestion = _this$state2.activeSuggestion,
        filteredSuggestions = _this$state2.filteredSuggestions,
        showSuggestions = _this$state2.showSuggestions,
        userInput = _this$state2.userInput,
        utilities = _this$state2.utilities,
        properties = _this$state2.properties,
        addProperties = _this$state2.addProperties,
        number = _this$state2.number,
        optionSelected = _this$state2.optionSelected;
      var suggestionsListComponent;
      if (showSuggestions && userInput) {
        if (filteredSuggestions.length) {
          suggestionsListComponent = /*#__PURE__*/_react["default"].createElement("ul", {
            "class": "suggestions"
          }, filteredSuggestions === null || filteredSuggestions === void 0 ? void 0 : filteredSuggestions.map(function (suggestion, index) {
            var className;

            // Flag the active suggestion with a class
            if (index === activeSuggestion) {
              className = "suggestion-active";
            }
            return (
              /*#__PURE__*/
              // <option onClick={onClick}value={suggestion.key} className={className}>{suggestion.title}</option>
              _react["default"].createElement("li", {
                className: className,
                key: suggestion.title,
                onClick: function onClick() {
                  return _onClick(suggestion);
                }
              }, suggestion.title)
            );
          }));
        } else {
          suggestionsListComponent = /*#__PURE__*/_react["default"].createElement("div", {
            "class": "no-suggestions"
          }, /*#__PURE__*/_react["default"].createElement("em", null, "No suggestions, you're on your own!"));
        }
      }
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, addProperties && utilities ? /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, utilities === null || utilities === void 0 ? void 0 : utilities.map(function (data) {
        var _data$properties;
        return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("h6", null, data.name, ":"), /*#__PURE__*/_react["default"].createElement("div", null, data === null || data === void 0 ? void 0 : (_data$properties = data.properties) === null || _data$properties === void 0 ? void 0 : _data$properties.map(function (value, index) {
          return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
            className: "row",
            key: index
          }, /*#__PURE__*/_react["default"].createElement("div", {
            className: "col-sm-4 position-relative"
          }, /*#__PURE__*/_react["default"].createElement("label", null, value === null || value === void 0 ? void 0 : value.label, /*#__PURE__*/_react["default"].createElement("button", {
            style: {
              position: "absolute",
              bottom: 0,
              right: 0,
              width: "32px",
              height: "100%",
              borderRadius: "4px",
              border: "1px solid #ccc",
              backgroundColor: "#f5f5f5",
              textAlign: "center",
              cursor: "pointer"
            },
            onClick: function onClick() {
              return deleteUtilities(data.name, index);
            }
          }, /*#__PURE__*/_react["default"].createElement("i", {
            className: "fa fa-times",
            style: {
              lineHeight: "36px"
            }
          }))))));
        })));
      })) : null, /*#__PURE__*/_react["default"].createElement("div", {
        className: "row"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "col"
      }, /*#__PURE__*/_react["default"].createElement("label", null, "Select Utlities")), /*#__PURE__*/_react["default"].createElement("div", {
        className: "col"
      }, /*#__PURE__*/_react["default"].createElement("label", null, "Select Properties"))), /*#__PURE__*/_react["default"].createElement("div", {
        className: "row"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "col"
      }, /*#__PURE__*/_react["default"].createElement("input", {
        type: "text",
        onChange: onChange,
        onKeyDown: onKeyDown,
        value: userInput
      }), suggestionsListComponent), properties && userInput ? /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
        className: "col"
      }, /*#__PURE__*/_react["default"].createElement(_MySelect["default"], {
        options: properties,
        isMulti: true,
        closeMenuOnSelect: false,
        hideSelectedOptions: false,
        components: {
          Option: Option,
          MultiValue: MultiValue,
          animatedComponents: animatedComponents
        },
        onChange: this.handleChange,
        allowSelectAll: true,
        value: this.state.optionSelected
      })), /*#__PURE__*/_react["default"].createElement("div", {
        className: "col-sm-3"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "dynamic-options-actions-buttons"
      }, /*#__PURE__*/_react["default"].createElement("button", {
        onClick: function onClick() {
          _this2.setState({
            addProperties: true
          });
          _this2.setState({
            userInput: ""
          });
          _this2.setState({
            optionSelected: ""
          });
          finalSelectedData(_this2.state.number);
        },
        className: "btn btn-success"
      }, /*#__PURE__*/_react["default"].createElement("i", {
        className: "fas fa-plus-circle"
      })), /*#__PURE__*/_react["default"].createElement("button", {
        className: "btn btn-danger"
      }, /*#__PURE__*/_react["default"].createElement("i", {
        className: "fas fa-minus-circle"
      }))))) : null), /*#__PURE__*/_react["default"].createElement("br", null));
    }
  }]);
  return Autocomplete;
}(_react.Component);
_defineProperty(Autocomplete, "propTypes", {
  suggestions: _propTypes["default"].instanceOf(Array)
});
_defineProperty(Autocomplete, "defaultProps", {
  suggestions: []
});
var _default = Autocomplete;
exports["default"] = _default;